#include "syntaxparser.hh"
#include "parser.hh"

#include <iostream>

#define COMPRESS_BITBUF     0
#define COMPRESS_DICTIONARY 1

#include "dictionary.hh"

static Syntax *syntaxparser;

static string fgetsstringtrans(const char *s, bool ctrlO = false)
{
	unsigned len = strlen(s);
	
	while(len > 0 && (s[len-1]=='\r' || s[len-1]=='\n'))
		--len;
	
	if(len > 0 && ctrlO)
		if(s[len-1]=='')--len;
	
	return string(s, len);
}

static string Decompress(BitBuf s)
{
#if COMPRESS_BITBUF
	s.Decompress();
	return s;
#elif COMPRESS_DICTIONARY
	return DictDecompress(s);
#else
	return s;
#endif
}
static BitBuf Compress(const string &s)
{
#if COMPRESS_BITBUF
	BitBuf result = s;
	result.Compress();
	return result;
#elif COMPRESS_DICTIONARY
	BitBuf result = DictCompress(s);
	// cerr << "Compressed " << s.size()*8 << " bits to " << result.size() << " bits\n";
	return result;
#else
	return BitBuf(s);
#endif
}

void Load(const char *s)
{
	syntaxparser = new Syntax(s);
}

int Encoded(const char *s)
{
	const char *q = rivitunniste;
	while(*s && *q)
		if(*q++ != *s++)return 0;
	return *q ? 0 : 1;
}
int Decode(const char *s)
{
	cout << Decompress(syntaxparser->Decode(fgetsstringtrans(s + strlen(rivitunniste), true))) << endl;
	return 0;
}
int Encode(const char *s)
{
	cout << rivitunniste << syntaxparser->Encode(Compress(fgetsstringtrans(s))) << "" << endl;
	return 0;
}
void Unload()
{
	delete syntaxparser;
	syntaxparser = NULL;
}
